
#define Ntap 2 
float ACoef[Ntap];
float BCoef[Ntap];
/******************************
Filter type: High Pass
Filter model: Bessel
Filter order: 1
Sampling Frequency: 61 Hz
Cut Frequency: 3 Hz
*******************************/
const float ACoef_S[Ntap] = {
       0.86326536068762083000,
       -0.86326536068762083000
    };
const float BCoef_S[Ntap] = {
      1.00000000000000000000,
      -0.72654252801660990000
    };
 //------------------------------
/******************************
Filter type: High Pass
Filter model: Bessel
Filter order: 1
Sampling Frequency: 61 Hz
Cut Frequency: 6 Hz
*******************************/

const float ACoef_N[Ntap] = {
       0.75801489474633166000,
        -0.75801489474633166000
    };
const float BCoef_N[Ntap] = {
      1.00000000000000000000,
      -0.51602978994703841000
    };
//------------------------------- 
/***************************
Filter type: High Pass
Filter model: Bessel
Filter order: 1
Sampling Frequency: 61 Hz
Cut Frequency: 12 Hz
****************************/
const float ACoef_F[Ntap] = {
        0.58448038104108058000,
        -0.58448038104108058000
    };
const float BCoef_F[Ntap] = {
      1.00000000000000000000,
      -0.16896076208216129000
    };
//------------------------------- 
float HPF_A(float NewSample) {
    
    static float y[Ntap]; //output samples
    static float x[Ntap]; //input samples
    if(Mem.Filter =='M')return NewSample*=-1;     
       x[1] = x[0];
       y[1] = y[0];
       x[0] = NewSample;
       y[0] = ACoef[0] * x[0] + ACoef[1] * x[1] - BCoef[1] * y[1]; 
    return y[0];
}

float HPF_B(float NewSample) {
    
    static float y[Ntap]; //output samples
    static float x[Ntap]; //input samples
    if(Mem.Filter =='M')return NewSample*=-1;
       x[1] = x[0];
       y[1] = y[0];
       x[0] = NewSample;
       y[0] = ACoef[0] * x[0] + ACoef[1] * x[1] - BCoef[1] * y[1];
    return y[0];
}
//------------------------------------------------------------------------------------------------------------------------
/**************************
Filter type: Low Pass
Filter model: Bessel
Filter order: 2
Sampling Frequency: 61 Hz
Cut Frequency: 12 Hz
***************************/

#define NCoef 2
const  float ACoef_L[NCoef+1] = {
        0.18467422174848974000,
        0.36934844349697948000,
        0.18467422174848974000
    };

const  float BCoef_L[NCoef+1] = {
       1.00000000000000000000,
       -0.36144237286899933000,
       0.10013925986295853000
    };

float LPF_A(float NewSample) {
   
    static float y[NCoef+1]; //output samples
    static float x[NCoef+1]; //input samples
    int n;

    //shift the old samples
    for(n=NCoef; n>0; n--) 
    {
       x[n] = x[n-1];
       y[n] = y[n-1];
    }

    //Calculate the new output
    x[0] = NewSample;
    y[0] = ACoef_L[0] * x[0];
    for(n=1; n<=NCoef; n++) y[0] += ACoef_L[n] * x[n] - BCoef_L[n] * y[n];
    
    return y[0];
}

float LPF_B(float NewSample) {
   
    static float y[NCoef+1]; //output samples
    static float x[NCoef+1]; //input samples
    int n;

    //shift the old samples
    for(n=NCoef; n>0; n--) 
    {
       x[n] = x[n-1];
       y[n] = y[n-1];
    }

    //Calculate the new output
    x[0] = NewSample;
    y[0] = ACoef_L[0] * x[0];
    for(n=1; n<=NCoef; n++) y[0] += ACoef_L[n] * x[n] - BCoef_L[n] * y[n];
    
    return y[0];
}

//----------------------------------------------------------------------------------------------------------------------------------------------

void Filter_set()
{
 for(int i=0; i<Ntap; i++)
  {  
   if( Mem.Filter =='S'){ACoef[i]=ACoef_S[i]; BCoef[i]=BCoef_S[i];}
   if( Mem.Filter =='N'){ACoef[i]=ACoef_N[i]; BCoef[i]=BCoef_N[i];}  
   if( Mem.Filter =='F'){ACoef[i]=ACoef_F[i]; BCoef[i]=BCoef_F[i];}       
  }
}


